<?xml version="1.0" encoding="UTF-8"?>
<!-- This XSL is created by Niko Siltala / Tampere University of Technology (TUT) / MEI
     niko.siltala(at)tut.fi-->
<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:me="http://resourcedescription.tut.fi/XMLSchema/2016" xmlns:eupass="http://www.eupass.org/2005/XMLSchema" xmlns="http://resourcedescription.tut.fi/XMLSchema/2016" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="no" cdata-section-elements="namelist" media-type="text/xml"/>
	<xsl:namespace-alias stylesheet-prefix="me" result-prefix="#default"/>
	<!--<xsl:namespace-alias stylesheet-prefix="me2" result-prefix="#default"/>-->
	<!--Creation of XSL Keys-->
	<xsl:key name="keyProfile" match="me:Profile" use="@id"/>
	<xsl:key name="keyCapa" match="me:Capability" use="@id"/>
	<xsl:key name="keyExecCapa" match="me:ExecCapa" use="@id"/>
	<xsl:key name="keyInterface" match="me:Interface" use="@id"/>
	<!--XSL Variables-->
	<xsl:variable name="var.profile">prof.testProfile.simple.1</xsl:variable>
	<!--prof.gripper.2-finger_simple.1-->
	<xsl:variable name="URLBase">http://resourcedescription.tut.fi/resourcedesc</xsl:variable>
	<xsl:variable name="var.ArdURL">http://resourcedescription.tut.fi/resourcedesc/ards/</xsl:variable>
	<!-- Go through all nodes-->
	<xsl:template match="@*|node()">
		<xsl:copy>
			<xsl:apply-templates select="@*|node()"/>
		</xsl:copy>
	</xsl:template>
	<!--
	Processing the document instance 
	-->
	<xsl:template match="/">
		<!--The processing instruction prevents user to see and save the description in XML format but instead in HTML
			<xsl:processing-instruction name="xml-stylesheet">type="text/xsl" href="<xsl:value-of select="$URLBase"/>/stylesheets/BP_FormatterBPDoc.xsl"</xsl:processing-instruction>-->
		<xsl:text disable-output-escaping="yes">
		&lt;!--&lt;?xml-stylesheet type="text/xsl" href="</xsl:text>
		<xsl:value-of select="$URLBase"/>
		<xsl:text disable-output-escaping="yes">/stylesheets/RD_FormatterRDDoc_v2-0-0.xsl"?&gt;--&gt;
		</xsl:text>
		<ResourceDescription id="TODO_ResourceID" gid="TODO_ResourceGID" name="TODO_NameOfResource" URL="TODO_URLOfThisRD" version="0.1" author="TODO_Author(s)" email="TODO_name.name@comany.com" company="TODO_CompanyName" phone="TODO_Phone">
			<xsl:attribute name="schemaVersion">2.0.0</xsl:attribute>
			<xsl:attribute name="created">2017-03-23T15:30:00+03:00</xsl:attribute>
			<!--<xsl:value-of select="current-dateTime()"/>-->
			<xsl:attribute name="modified">2017-03-23T15:30:00+03:00</xsl:attribute>
			<!--<xsl:value-of select="current-dateTime()"/>-->
			<xsl:attribute name="xsi:schemaLocation">http://resourcedescription.tut.fi/XMLSchema/2016 http://resourcedescription.tut.fi/resourcedesc/schemas/ResourceDesc_v2-0-0.xsd</xsl:attribute>
			<!--Insert Comment Note into the generated outputfile-->
			<xsl:text disable-output-escaping="yes">
			&lt;!--NOTE! CAUTION! THIS FILE IS AUTOMATICALLY GENERATED! 
			Intention is to offer a RDSkeleton (or Template) for Resource Description (RD) file editors!--&gt;
			</xsl:text>
			<!--Copy the Shared resources from ARD-->
			<xsl:apply-templates select="//me:AbstractResourceDesc/me:SharedResources"   mode="copy-no-namespaces"/>
			<!--TODO Pick out the selective properties defined by the Profiles-->
			<Resource id="TODO_ResourceID" gid="TODO_ResourceGID" URL="TODO_URLOfThisRD" name="TODO_NameOfResource" category="PROCESS_MODULE">
					<xsl:attribute name="ardIDRef"><xsl:value-of select="//me:AbstractResourceDesc/@ardID"/></xsl:attribute>
					<xsl:attribute name="ardGIDRef"><xsl:value-of select="//me:AbstractResourceDesc/@ardGID"/></xsl:attribute>
					<xsl:attribute name="ardProfileIDRef"><xsl:value-of select="$var.profile"/></xsl:attribute>
					<xsl:attribute name="ardURL"><xsl:value-of select="$var.ArdURL"/></xsl:attribute>
				<!--Create Info element-->
				<GeneralInfo>
					<Label lang="en">TODO_RDLabel</Label>
					<Comment lang="en">TODO_OPT_RDComment</Comment>
					<Documentation name="TODO_NameForDocumentation" type="TODO_TypeOfDocumentation">
						<Link>
							<Label lang="en">TODO_OPT_DocumentationLabel</Label>
							<URI>http://www.TODO_company.com</URI>
						</Link>
						<XHTML>TODO_OPT_XHTMLDocumentation</XHTML>
					</Documentation>
					<!--Create Vendor element-->
					<Vendor id="TODO_name">
						<NameLoc lang="en">TODO_nameOfCompany</NameLoc>
						<Link>
							<Label lang="en">TODO_labelOfWebPage</Label>
							<URI>http://www.TODO_company.com/</URI>
						</Link>
					</Vendor>
					<!-- Classification information for RD -->
					<xsl:apply-templates select="key('keyProfile', $var.profile)/me:ProfileInfo/me:Classification"  mode="copy-no-namespaces"/>
					<!-- TODO Apply templates for classification -> look from Profile(s) recursively? -->
					<xsl:apply-templates select="//me:AbstractResourceDesc/me:AbstractModelOfEquipment" mode="copy-no-namespaces"/>
					<FunctionalDescription/>
					<File_Image format="PNG" name="TODO_NameOfImage" URL="http://www.TODO_company.com">
						<XHTML>TODO_OPT_XHTML_Description</XHTML>
					</File_Image>
					<File_CAD format="STEP" name="TODO_NameOfCADFile" URL="http://www.TODO_company.com">
						<XHTML>TODO_OPT_XHTML_Description</XHTML>
					</File_CAD>
				</GeneralInfo>
				<InterfacesInfo>
					<xsl:apply-templates select="//me:AbstractResourceDesc/me:AbstractInterfacePorts" mode="copy-no-namespaces"/>
					<xsl:apply-templates select="//me:AbstractResourceDesc/me:StdBodies" mode="copy-no-namespaces"/>
					<InterfaceStds>
						<xsl:apply-templates select="//me:AbstractResourceDesc/me:Interfaces/*" mode="copy-no-namespaces"/>
					</InterfaceStds>
					<IFImplementations>
						<Mechanic>
							<Interfaces>
								<!--Picks the wanted profile-->
								<xsl:apply-templates select="key('keyProfile', $var.profile)" mode="withIFCategory">
									<xsl:with-param name="ifCategory">MECHANICAL_PORT</xsl:with-param>
	<!--		Sorting does not function because of recursion and use of extended references. 
									<xsl:sort select="@abstractInterfacePortRef" order="ascending"/>
									<xsl:sort select="@interfaceStdRef" order="ascending"/>
									<xsl:sort select="@interfacePortRefQualifier" order="ascending"/> -->
								</xsl:apply-templates>
							</Interfaces>
						</Mechanic>
						<Service>
							<Interfaces>
								<!--Picks the wanted profile-->
								<xsl:apply-templates select="key('keyProfile', $var.profile)" mode="withIFCategory">
									<xsl:with-param name="ifCategory">SERVICE_PORT</xsl:with-param>
								</xsl:apply-templates>
							</Interfaces>
						</Service>
						<Electric>
							<Interfaces>
								<!--Picks the wanted profile-->
								<xsl:apply-templates select="key('keyProfile', $var.profile)" mode="withIFCategory">
									<xsl:with-param name="ifCategory">ELECTRICAL_PORT</xsl:with-param>
								</xsl:apply-templates>
							</Interfaces>
						</Electric>
						<Communication>
							<Interfaces>
								<!--Picks the wanted profile-->
								<xsl:apply-templates select="key('keyProfile', $var.profile)" mode="withIFCategory">
									<xsl:with-param name="ifCategory">COMMUNICATION_PORT</xsl:with-param>
								</xsl:apply-templates>
							</Interfaces>
						</Communication>
					</IFImplementations>
				</InterfacesInfo>
				<Capabilities>
<!--					<xsl:apply-templates select="//me:AbstractResourceDesc/me:Capabilities/*" mode="copy-no-namespaces"/> -->
						<xsl:apply-templates select="//me:AbstractResourceDesc/me:Capabilities/me:PlaceHolder_CapabilityModelAsOWL"/>
						<!--Picks the wanted profile-->
						<xsl:apply-templates select="key('keyProfile', $var.profile)" mode="forCapability">
							<xsl:sort select="@id" order="ascending"/>
						</xsl:apply-templates>
				</Capabilities>
				<ExecCapabilities>
					<SharedPortSymbols>
						<!-- TODO Copy selected parameters and properties here!
						<Symbol id="" name="" datatype=""/>
						 -->
					</SharedPortSymbols>
					<ExecCapas>
						<!--Picks the wanted profile-->
						<xsl:apply-templates select="key('keyProfile', $var.profile)" mode="forExecCapas">
							<xsl:sort select="@id" order="ascending"/>
						</xsl:apply-templates>
					</ExecCapas>
					<ConnectionMethodsForCtrlAndComm/>
					<Implementation/>
				</ExecCapabilities>
				<SharedResources/>
				<Properties>
					<!--Copy the Shared resources-->
					<SelectiveProperties>
						<!--Picks the wanted profile-->
						<xsl:apply-templates select="key('keyProfile', $var.profile)" mode="withSelectiveProperties">
							<xsl:sort select="@id | @idRef" order="ascending"/>
							<xsl:with-param name="phase">1</xsl:with-param>
						</xsl:apply-templates>
						<xsl:apply-templates select="key('keyProfile', $var.profile)" mode="withSelectiveProperties">
							<xsl:sort select="@id | @idRef" order="ascending"/>
							<xsl:with-param name="phase">2</xsl:with-param>
						</xsl:apply-templates>
					</SelectiveProperties>
					<PhysicalProperties>
						<Mass value="0" unit="kg"/>
						<InstallationPositions limited="false">
							<AccelerationLimits increment="0.1" decade="0" unit="m/s^2" rot_increment="0.1" rot_decade="0" rot_unit="rad/s^2">
								<Min x="-0" y="-0" z="-0" rot_x="-0" rot_y="-0" rot_z="-0"/>
								<Max x="0" y="0" z="0" rot_x="0" rot_y="0" rot_z="0"/>
							</AccelerationLimits>
							<DescriptionLimitations URL="" lang="en">TODO_OPT_XHTMLDocumentation</DescriptionLimitations>
						</InstallationPositions>
						<LocalOrigin iFInstanceRef="TODO_IDREF">
							<XHTML>
								<xsl:apply-templates select="//me:AbstractResourceDesc/me:LocalOrigin/*" mode="copy-no-namespaces"/>
							</XHTML>
						</LocalOrigin>
						<BoundingBox increment="0.0001" decade="0" unit="m">
							<Min x="-0" y="-0" z="-0"/>
							<Max x="0" y="0" z="0"/>
						</BoundingBox>						
						<CentreOfGravity x="0.0" y="0.0" z="0.0"/>
						<PowerSupplyElectrical voltageRangeMin="13.0" voltageNominal="24" voltageRangeMax="30.0" currentNominal="0" currentMax="0" currentMaxPassThrough="0" AC_or_DC="DC" requiresUPS="false" cutOffByEmergencyStop="false"/>
						<PowerSupplyPneumatic pressureRangeMin="4" pressureNominal="6" pressureRangeMax="8" unit="Pa" decade="5" cutOffByEmergencyStop="false"/>
					</PhysicalProperties>
					<TechnicalProperties>
						<!--Picks the wanted profile-->
						<xsl:apply-templates select="key('keyProfile', $var.profile)" mode="withTechnicalProperties">
							<xsl:sort select="@id|@idRef" order="ascending"/>
							<xsl:with-param name="phase">1</xsl:with-param>
						</xsl:apply-templates>
						<xsl:apply-templates select="key('keyProfile', $var.profile)" mode="withTechnicalProperties">
							<xsl:sort select="@id|@idRef" order="ascending"/>
							<xsl:with-param name="phase">2</xsl:with-param>
						</xsl:apply-templates>
					</TechnicalProperties>
					<BusinessAndLifeCycleProperties>
						<!--TODO make copying-->
						<!--Picks the wanted profile-->
						<xsl:apply-templates select="key('keyProfile', $var.profile)" mode="withBusinessProperties">
							<xsl:sort select="@id" order="ascending"/>
						</xsl:apply-templates>
					</BusinessAndLifeCycleProperties>
					<EnvironmentalProperties>
						<!--TODO make copying-->
						<!--Picks the wanted profile-->
						<xsl:apply-templates select="key('keyProfile', $var.profile)" mode="withEnvironmentalProperties">
							<xsl:sort select="@id" order="ascending"/>
						</xsl:apply-templates>
					</EnvironmentalProperties>
				</Properties>
				<!-- GUIs related information and definitions. For future usage -->
				<GUIsInfo/>
				<Calibration>
					<Label lang="en">TODO_OPT_CalibrationName</Label>
					<Comment lang="en">TODO_OPT_CalibrationComment</Comment>
					<Documentation name="TODO_NameForDocumentation" type="TODO_TypeOfDocumentation">
						<Link>
							<Label lang="en">TODO_OPT_CalibrationDocumentation</Label>
							<URI>http://www.TODO_company.com</URI>
						</Link>
						<XHTML>TODO_OPT_XHTMLDocumentation</XHTML>
					</Documentation>
				</Calibration>
				<TestProcedures>
					<Label lang="en">TODO_OPT_TestProcedureName</Label>
					<Comment lang="en">TODO_OPT_TestProcedureComment</Comment>
					<Documentation name="TODO_NameForDocumentation" type="TODO_TypeOfDocumentation">
						<Link>
							<Label lang="en">TODO_OPT_TestProcedureDocumentation</Label>
							<URI>http://www.TODO_company.com</URI>
						</Link>
						<XHTML>TODO_OPT_XHTMLDocumentation</XHTML>
					</Documentation>
				</TestProcedures>
				<HardwareVersion>
					<VersionNumber>TODO_VersionNumber</VersionNumber>
					<DateTime>2017-03-23T15:30:00+03:00</DateTime>
				</HardwareVersion>
			</Resource>
			<!--Add the version information-->
			<DescriptionVersion>
				<VersionNumber>TODO_VersionNumber</VersionNumber>
				<DateTime>2017-03-23T15:30:00+03:00</DateTime>
			</DescriptionVersion>
			<SerialNumber>1234</SerialNumber>
		</ResourceDescription>
	</xsl:template>
	<!--
	 Component templates
	 -->
<!--	<xsl:template match="@*|node()|comment()">
		<xsl:copy>
			<xsl:apply-templates select="@*|node()|comment()"/>
		</xsl:copy>
	</xsl:template> -->
	<xsl:template match="*" mode="copy-no-namespaces">
		<xsl:element name="{local-name()}">
			<xsl:copy-of select="@*"/>
			<xsl:apply-templates select="node()" mode="copy-no-namespaces"/>
		</xsl:element>
	</xsl:template>
	<xsl:template match="comment()|processing-instruction()" mode="copy-no-namespaces">
		<xsl:copy/>
	</xsl:template>
	<!-- Template for Profile / forCapability -->
	<xsl:template match="me:Profile" mode="forCapability">
		<!-- <debug> Profile Processed: <xsl:value-of select="@name"/>-->
		<!--Capas of a profile-->
		<!--Looks through all referenced Profiles-->
		<xsl:apply-templates select="./me:ExtendRef" mode="forCapability"/>
		<xsl:if test="count(./me:CapabilityRefs/me:CapabilityRef)>0">
			<!-- <debug> From Profile: this-->
			<xsl:apply-templates select="./me:CapabilityRefs/me:CapabilityRef" mode="inProfile">
				<xsl:sort select="@reqOpt" order="descending"/>
				<xsl:sort select="@idRef" order="ascending"/>
			</xsl:apply-templates>
		</xsl:if>
	</xsl:template>
	<!-- Template for Profile / forExecCapas-->
	<xsl:template match="me:Profile" mode="forExecCapas">
		<!-- <debug> Profile Processed: <xsl:value-of select="@name"/>-->
		<!--ExecCapas of a profile-->
		<!--Looks through all referenced Profiles-->
		<xsl:apply-templates select="./me:ExtendRef" mode="forExecCapas"/>
		<xsl:if test="count(./me:ExecCapaRefs/me:ExecCapaRef)>0">
			<!-- <debug> From Profile: this-->
			<xsl:apply-templates select="./me:ExecCapaRefs/me:ExecCapaRef" mode="inProfile">
				<xsl:sort select="@reqOpt" order="descending"/>
				<xsl:sort select="@idRef" order="ascending"/>
			</xsl:apply-templates>
		</xsl:if>
	</xsl:template>
	<!-- Template for Profile / withIFCategory-->
	<xsl:template match="me:Profile" mode="withIFCategory">
		<xsl:param name="ifCategory"/>
		<xsl:param name="reqOpt-successor"/>
		<!--DEBUG: In Profile: <xsl:value-of select="./@id"/> with IFType: <xsl:value-of select="$ifCategory"/>-->
		<!--Looks through all referenced Profiles-->
		<xsl:apply-templates select="./me:ExtendRef" mode="withIFCategory">
			<xsl:with-param name="ifCategory">
				<xsl:value-of select="$ifCategory"/>
			</xsl:with-param>
			<xsl:with-param name="reqOpt-successor">
				<xsl:choose>
					<xsl:when test="$reqOpt-successor = 'OPT' ">OPT</xsl:when>
					<xsl:when test="string-length(./me:ExtendRef/@reqOpt) = 0">REQ</xsl:when>
					<xsl:otherwise><xsl:value-of select="./me:ExtendRef/@reqOpt"/></xsl:otherwise>
				</xsl:choose>
			</xsl:with-param>
		</xsl:apply-templates>
		<xsl:if test="count(./me:InterfaceRefs/me:InterfaceRef[@ifCategory=$ifCategory])>0">
			<!--DEBUG: from Profile: <xsl:value-of select="./@id"/>-->
			<!--DEBUG: from Profile: ReqOpt successor = <xsl:value-of select="$reqOpt-successor"/>-->
			<xsl:apply-templates select="./me:InterfaceRefs/me:InterfaceRef[@ifCategory=$ifCategory]">
				<xsl:with-param name="ifCategory">
					<xsl:value-of select="$ifCategory"/>
				</xsl:with-param>
				<xsl:with-param name="reqOpt-successor">
					<xsl:value-of select="$reqOpt-successor"/>
				</xsl:with-param>
			</xsl:apply-templates>
		</xsl:if>
	</xsl:template>
	<!-- Template for Profile / withSelectiveProperties-->
	<xsl:template match="me:Profile" mode="withSelectiveProperties">
		<xsl:param name="phase"/>
		<!--Looks through all referenced Profiles-->
		<xsl:for-each select="./me:ExtendRef">
			<xsl:apply-templates select="key('keyProfile', .)" mode="withSelectiveProperties">
				<xsl:with-param name="phase">
					<xsl:value-of select="$phase"/>
				</xsl:with-param>
			</xsl:apply-templates>
		</xsl:for-each>
		<xsl:for-each select="./me:SelectiveProperties">
			<xsl:if test="$phase=1">
				<xsl:copy-of select="./me:Variable | ./me:VariableBoolean | ./me:VariableNum | ./me:VariableString"/>
			</xsl:if>
			<xsl:if test="$phase=2">
				<xsl:copy-of select="./me:VariableRef"/>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>
	<!-- Template for Profile / withTechnicalProperties-->
	<xsl:template match="me:Profile" mode="withTechnicalProperties">
		<xsl:param name="phase"/>
		<xsl:param name="reqOpt-successor"/>
		<!--Looks through all referenced Profiles-->
		<xsl:for-each select="./me:ExtendRef">
			<xsl:apply-templates select="key('keyProfile', .)" mode="withTechnicalProperties">
				<xsl:with-param name="phase">
					<xsl:value-of select="$phase"/>
				</xsl:with-param>
				<xsl:with-param name="reqOpt-successor">
					<xsl:choose>
						<xsl:when test="$reqOpt-successor = 'OPT' ">OPT</xsl:when>
						<xsl:when test="string-length(@reqOpt) = 0">REQ</xsl:when>
						<xsl:otherwise><xsl:value-of select="@reqOpt"/></xsl:otherwise>
					</xsl:choose>
				</xsl:with-param>
			</xsl:apply-templates>
		</xsl:for-each>
		<xsl:for-each select="./me:Properties/me:TechnicalProperties">
			<xsl:if test="$phase=1">
				<xsl:for-each select="./me:Variable | ./me:VariableBoolean | ./me:VariableNum | ./me:VariableString">
					<xsl:sort select="@reqOpt" order="descending"/>
					<xsl:sort select="@id | @idRef" order="ascending"/>
					<xsl:copy>
						<xsl:copy-of select="./@*"/>
						<xsl:if test="$reqOpt-successor = 'OPT' ">
							<xsl:attribute name="reqOpt">OPT</xsl:attribute>
						</xsl:if>
						<xsl:attribute name="value">0</xsl:attribute>
					</xsl:copy>
				</xsl:for-each>
			</xsl:if>
			<xsl:if test="$phase=2">
				<xsl:for-each select="./me:VariableRef">
					<xsl:sort select="@reqOpt" order="descending"/>
					<xsl:sort select="@id | @idRef" order="ascending"/>
					<xsl:copy>
						<xsl:copy-of select="./@*"/>
						<xsl:if test="$reqOpt-successor = 'OPT' ">
							<xsl:attribute name="reqOpt">OPT</xsl:attribute>
						</xsl:if>
						<xsl:attribute name="value">0</xsl:attribute>
					</xsl:copy>
				</xsl:for-each>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>
	<!-- Template for Profile / withEnvironmentalProperties-->
	<xsl:template match="me:Profile" mode="withEnvironmentalProperties">
		<xsl:param name="reqOpt-successor"/>
		<!--Looks through all referenced Profiles-->
		<xsl:for-each select="./me:ExtendRef">
			<xsl:apply-templates select="key('keyProfile', .)" mode="withEnvironmentalProperties">
				<xsl:with-param name="reqOpt-successor">
					<xsl:choose>
						<xsl:when test="$reqOpt-successor = 'OPT' ">OPT</xsl:when>
						<xsl:when test="string-length(@reqOpt) = 0">REQ</xsl:when>
						<xsl:otherwise><xsl:value-of select="@reqOpt"/></xsl:otherwise>
					</xsl:choose>
				</xsl:with-param>
			</xsl:apply-templates>
		</xsl:for-each>
		<xsl:if test="count(./me:Properties/me:EnvironmentalProperties/*)>0">
			<xsl:for-each select="./me:Properties/me:EnvironmentalProperties/*">
				<xsl:sort select="@reqOpt" order="descending"/>
				<xsl:sort select="@id | @idRef" order="ascending"/>
				<xsl:copy>
					<xsl:copy-of select="@classOfEnvProperty|@reqOpt|@id|@idRef|@gid|@name|@datatype|@unit|@decade|@increment|@eClassIRDI_Ref|@description"/>
					<xsl:if test="$reqOpt-successor = 'OPT' ">
						<xsl:attribute name="reqOpt">OPT</xsl:attribute>
					</xsl:if>					
					<!--If min has been specified use that value-->
					<xsl:choose>
						<xsl:when test="@min!=0">
							<xsl:copy-of select="@min"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="min">0</xsl:attribute>
						</xsl:otherwise>
					</xsl:choose>
					<!--If max has been specified use that value-->
					<xsl:choose>
						<xsl:when test="@max!=0">
							<xsl:copy-of select="@max"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="max">0</xsl:attribute>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:copy>
				<xsl:copy-of select="@value|@defaultValue"/>
			</xsl:for-each>
		</xsl:if>
	</xsl:template>
	<!-- Template for Profile / withBusinessProperties-->
	<xsl:template match="me:Profile" mode="withBusinessProperties">
		<xsl:param name="reqOpt-successor"/>
		<!--Looks through all referenced Profiles-->
		<xsl:for-each select="./me:ExtendRef">
			<xsl:apply-templates select="key('keyProfile', .)" mode="withBusinessProperties">
				<xsl:with-param name="reqOpt-successor">
					<xsl:choose>
						<xsl:when test="$reqOpt-successor = 'OPT' ">OPT</xsl:when>
						<xsl:when test="string-length(@reqOpt) = 0">REQ</xsl:when>
						<xsl:otherwise><xsl:value-of select="@reqOpt"/></xsl:otherwise>
					</xsl:choose>
				</xsl:with-param>
			</xsl:apply-templates>
		</xsl:for-each>
		<xsl:if test="count(./me:Properties/me:BusinessAndLifeCycleProperties/*)>0">
			<xsl:for-each select="./me:Properties/me:BusinessAndLifeCycleProperties/*">
				<xsl:sort select="@reqOpt" order="descending"/>
				<xsl:sort select="@id | @idRef" order="ascending"/>
				<xsl:copy>
					<xsl:copy-of select="@classOfBusinessProperty|@reqOpt|@id|@idRef|@gid|@name|@datatype|@unit|@decade|@increment|@eClassIRDI_Ref|@description"/>
					<xsl:if test="$reqOpt-successor = 'OPT' ">
						<xsl:attribute name="reqOpt">OPT</xsl:attribute>
					</xsl:if>					
					<!--place values of min &max if defined-->
					<xsl:copy-of select="@min|@max|@defaultValue"/>
					<!--If value has been specified use that value-->
					<xsl:choose>
						<xsl:when test="@value!=0">
							<xsl:copy-of select="@value"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="value">0</xsl:attribute>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:copy>
			</xsl:for-each>
		</xsl:if>
	</xsl:template>
	<!-- End of Template for Profiles-->
	<!--Template for ExtendRef / forCapability -->
	<xsl:template match="me:ExtendRef" mode="forCapability">
		<xsl:variable name="extRef" select="."/>
		<!--Sets the default value for reqOpt, if missing-->
		<xsl:variable name="reqOpt">
			<xsl:choose>
				<xsl:when test="string-length(./@reqOpt)=0">REQ</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="./@reqOpt"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!-- calls Profiles recursively -->
		<xsl:apply-templates select="key('keyProfile',$extRef)" mode="forCapability"/>
	</xsl:template>
	<!--Template for ExtendRef / forCapability -->
	<xsl:template match="me:ExtendRef" mode="forCapability_ORIGINAL">
		<xsl:variable name="extRef" select="."/>
		<!--Sets the default value for reqOpt, if missing-->
		<xsl:variable name="reqOpt">
			<xsl:choose>
				<xsl:when test="string-length(./@reqOpt)=0">REQ</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="./@reqOpt"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:for-each select="key('keyProfile',$extRef)">
			<!-- Following statement makes the recursion loop-->
			<xsl:apply-templates select="./me:ExtendRef" mode="forCapability"/>
			<xsl:if test="count(./me:CapabilityRefs/me:CapabilityRef)>0">
				<!-- <DEBUG>Next set is <xsl:value-of select="$reqOpt"/> from Profile: <xsl:value-of select="@id"/>-->
				<xsl:apply-templates select="./me:CapabilityRefs/me:CapabilityRef" mode="inProfile">
					<xsl:sort select="@reqOpt" order="descending"/>
					<xsl:sort select="@idRef" order="ascending"/>
				</xsl:apply-templates>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>
	<!--Template for ExtendRef / forExecCapas -->
	<xsl:template match="me:ExtendRef" mode="forExecCapas">
		<xsl:variable name="extRef" select="."/>
		<!--Sets the default value for reqOpt, if missing-->
		<xsl:variable name="reqOpt">
			<xsl:choose>
				<xsl:when test="string-length(./@reqOpt)=0">REQ</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="./@reqOpt"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:for-each select="key('keyProfile',$extRef)">
			<!-- Following statement makes the recursion loop-->
			<xsl:apply-templates select="./me:ExtendRef" mode="forExecCapas"/>
			<xsl:if test="count(./me:ExecCapaRefs/me:ExecCapaRef)>0">
				<!-- <DEBUG>Next set is <xsl:value-of select="$reqOpt"/> from Profile: <xsl:value-of select="@id"/>-->
				<xsl:apply-templates select="./me:ExecCapaRefs/me:ExecCapaRef" mode="inProfile">
					<xsl:sort select="@reqOpt" order="descending"/>
					<xsl:sort select="@idRef" order="ascending"/>
				</xsl:apply-templates>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>
	<!--Template for ExtendRef / IFCategory -->
	<xsl:template match="me:ExtendRef" mode="withIFCategory">
		<xsl:param name="ifCategory"/>
		<xsl:param name="reqOpt-successor"/>
		<xsl:variable name="extRef" select="."/>
		<!--DEBUG: Goes to extension: <xsl:value-of select="."/> with IFType: <xsl:value-of select="$ifCategory"/>-->
		<!--Sets the default value for reqOpt, if missing-->
		<xsl:variable name="reqOpt">
			<xsl:choose>
				<xsl:when test="$reqOpt-successor = 'OPT' ">OPT</xsl:when>
				<xsl:when test="string-length(./@reqOpt) = 0">REQ</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="./@reqOpt"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!-- Following statement makes the recursion loop-->
		<!--This will process the referenced profile definition-->
		<xsl:apply-templates select="key('keyProfile', $extRef)" mode="withIFCategory">
			<xsl:with-param name="ifCategory">
				<xsl:value-of select="$ifCategory"/>
			</xsl:with-param>
			<xsl:with-param name="reqOpt-successor">
				<xsl:value-of select="$reqOpt"/>
			</xsl:with-param>
		</xsl:apply-templates>
	</xsl:template>
	<!--Template for InterfaceRef-->
	<xsl:template match="me:InterfaceRef">
		<xsl:param name="ifCategory"/>
		<xsl:param name="reqOpt-successor"/>
		<!--Creates interface reference ID string-->
		<xsl:variable name="IF_ID">
			<xsl:value-of select="./@ifCategory"/>-<xsl:value-of select="./@abstractInterfacePortRef"/>-<xsl:value-of select="./@interfaceStdRef"/>
			<xsl:choose>
				<xsl:when test="./@gender = 'MALE' ">-M</xsl:when>
				<xsl:when test="./@gender = 'FEMALE' ">-F</xsl:when>
				<xsl:otherwise>-N</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<Interface>
			<xsl:attribute name="id"><xsl:value-of select="$IF_ID"/></xsl:attribute>
			<!--DEBUG: InterfaceRef - reqOpt-successor = <xsl:value-of select="$reqOpt-successor"/>-->
			<xsl:element name="InterfaceRef">
				<xsl:copy-of select="@*"/>
				<xsl:if test="$reqOpt-successor = 'OPT' "> <!-- Update value of reqOpt attribute -->
					<xsl:attribute name="reqOpt">OPT</xsl:attribute>
				</xsl:if>
				<xsl:apply-templates select="./*" mode="copy-no-namespaces"/>
				<!--Copy Class and Option -elements related to interface-->
				<xsl:for-each select="key('keyInterface', ./@interfaceStdRef)">
					<xsl:copy-of select="./*[@ifCategory=$ifCategory]"/>
				</xsl:for-each>
			</xsl:element>
			<xsl:if test="$ifCategory = 'MECHANICAL_PORT' ">
				<!-- add optional element 'ForceAndTorqueLimits' only in case of mechanical interface -->
				<ForceAndTorqueLimits increment="0.1" decade="0" unit="N" rot_increment="0.1" rot_decade="0" rot_unit="Nm">
					<Min x="-0" y="-0" z="-0" rot_x="-0" rot_y="-0" rot_z="-0"/>
					<Max x="0" y="0" z="0" rot_x="0" rot_y="0" rot_z="0"/>
				</ForceAndTorqueLimits>
			</xsl:if>
			<Instances>
				<xsl:call-template name="Instance">
					<xsl:with-param name="IF_ID">
						<xsl:value-of select="$IF_ID"/>
					</xsl:with-param>
					<xsl:with-param name="counter">1</xsl:with-param>
					<xsl:with-param name="limit">
						<xsl:value-of select="@minOcc"/>
					</xsl:with-param>
				</xsl:call-template>
			</Instances>
		</Interface>
	</xsl:template>
	<!--Template for Name : Instance-->
	<xsl:template name="Instance">
		<xsl:param name="IF_ID"/>
		<xsl:param name="counter"/>
		<xsl:param name="limit"/>
		<Instance reqOpt="REQ">
			<xsl:attribute name="id"><xsl:value-of select="$IF_ID"/>-<xsl:value-of select="$counter"/></xsl:attribute>
			<xsl:attribute name="interfacePortRefQualifier"><xsl:value-of select="$counter"/></xsl:attribute>
			<Location x="0.0" y="0.0" z="0.0"/>
			<Orientation angle="0.0" x="0.0" y="0.0" z="0.0"/>
		</Instance>
		<!-- do recursion if counter is smaller than limit (counter < limit) -->
		<xsl:if test="$counter&lt;$limit">
			<xsl:call-template name="Instance">
				<xsl:with-param name="IF_ID">
					<xsl:value-of select="$IF_ID"/>
				</xsl:with-param>
				<xsl:with-param name="counter">
					<xsl:value-of select="$counter+1"/>
				</xsl:with-param>
				<xsl:with-param name="limit">
					<xsl:value-of select="$limit"/>
				</xsl:with-param>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>
	<!--Template for SharedResources-->
<!--	<xsl:template match="me:SharedResources">
		<Datatypes>
			<StringType id="dt.STRING.TODO_DEFINE" arrayLength="128" name="STRING"/>
			<xsl:copy-of select="./me:Datatypes/*"/>
		</Datatypes>
		<SelectiveProperties>
			<xsl:copy-of select="./me:SelectiveProperties/*"/>
		</SelectiveProperties>
		<Properties>
			<xsl:copy-of select="./me:Properties/*"/>
		</Properties>
		<Variables>
			<xsl:copy-of select="./me:Variables/*"/>
		</Variables>
	</xsl:template> -->
	
	<!--Template for CapabilityRef -->
	<xsl:template match="me:CapabilityRef" mode="inProfile">
		<xsl:variable name="capaID" select="@idRef"/>
		<!-- <debug> The Capability: <xsl:value-of select="@idRef"/> is <xsl:value-of select="@reqOpt"/>.-->
		<!--Selects proper Capability and calls it template = copies its all content -->
		<xsl:apply-templates select="key('keyCapa',$capaID)" mode="forCapability">
			<xsl:with-param name="reqOpt" select="@reqOpt"/>
		</xsl:apply-templates> 
	</xsl:template>
	<!--Template for Capability -->
	<xsl:template match="me:Capability" mode="forCapability">
		<xsl:param name="reqOpt"/>
		<xsl:element name="{name()}">
			<!--Copies internal structure -->
			<xsl:apply-templates select="@*"/>
			<xsl:attribute name="reqOpt"><xsl:value-of select="$reqOpt"/></xsl:attribute>
			<xsl:apply-templates select="node()"/>
		</xsl:element>
	</xsl:template>
	<!--Template for ExecCapaRef -->
	<xsl:template match="me:ExecCapaRef" mode="inProfile">
		<xsl:variable name="actID" select="@idRef"/>
		<!-- <debug> The ExecCapa: <xsl:value-of select="@idRef"/> is <xsl:value-of select="@reqOpt"/>.-->
		<!--Selects proper ExecCapa-->
		<xsl:apply-templates select="key('keyExecCapa',$actID)" mode="forExecCapas">
			<xsl:with-param name="reqOpt" select="@reqOpt"/>
		</xsl:apply-templates> 
	</xsl:template>
	<!--Template for ExecCapa-->
	<xsl:template match="me:ExecCapa" mode="forExecCapas">
		<xsl:param name="reqOpt"/>
		<xsl:element name="{name()}">
			<!-- copies all attributes but class -->
			<xsl:apply-templates select="@*[name()!='class']"/>
			<!-- update reqOpt -->
			<xsl:attribute name="reqOpt"><xsl:value-of select="$reqOpt"/></xsl:attribute>
			<!-- Process and copy all elements but not ParameterPorts -->
			<!-- <xsl:apply-templates select="*[not(local-name()='ParameterPorts')]"/>
			<xsl:apply-templates select="./me:ParameterPorts" mode="forExecCapas"/> -->
			<xsl:apply-templates select="./me:Label"/>
			<xsl:apply-templates select="./me:Comment"/>
			<xsl:apply-templates select="./me:Documentation"/>
			<xsl:apply-templates select="./me:ParentExecCapas"/>
			<xsl:apply-templates select="./me:Mappings"/>
			<xsl:apply-templates select="./me:EventPorts"/>
			<xsl:apply-templates select="./me:ParameterPorts" mode="forExecCapas"/>
			<xsl:apply-templates select="./me:ConnectionMethods"/>
			<Implementation/>
		</xsl:element>
	</xsl:template>
	<xsl:template match="me:ExecCapa" mode="forExecCapas_OLD">
		<ExecCapa>
			<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
			<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
			<xsl:attribute name="category">EXEC_CAPABILITY</xsl:attribute>
			<xsl:attribute name="class">ACTION</xsl:attribute>
			<Label lang="en"><xsl:value-of select="@name"/></Label>
			<Comment lang="en"><xsl:value-of select="@description"/></Comment>
			<Documentation name="TODO_NameForDocumentation" type="TODO_TypeOfDocumentation">
				<Link>
					<Label lang="en">TODO_OPT_Documentation</Label>
					<URI>http://www.TODO_company.com</URI>
				</Link>
			</Documentation>
			<ParentExecCapas/>
			<Mappings/>
			<ControlPorts>
				<Inputs>
					<xsl:apply-templates select="./me:ControlPorts/me:Inputs" mode="forExecCapas">
						<xsl:sort select="@id|@idRef" order="ascending"/>
					</xsl:apply-templates>
				</Inputs>
				<Outputs>
					<xsl:apply-templates select="./me:ControlPorts/me:Outputs" mode="forExecCapas">
						<xsl:sort select="@id|@idRef" order="ascending"/>
					</xsl:apply-templates>
				</Outputs>
			</ControlPorts>
			<ParameterPorts>
				<Inputs>
					<xsl:apply-templates select="./me:ParameterPorts/me:Inputs" mode="forExecCapas">
						<xsl:sort select="@id|@idRef" order="ascending"/>
					</xsl:apply-templates>
				</Inputs>
				<Outputs>
					<xsl:apply-templates select="./me:ParameterPorts/me:Outputs" mode="forExecCapas">
						<xsl:sort select="@id|@idRef" order="ascending"/>
					</xsl:apply-templates>
				</Outputs>
			</ParameterPorts>
			<Implementation/>
		</ExecCapa>
	</xsl:template>
	<!--Template for Inputs-->
	<xsl:template match="me:ParameterPorts" mode="forExecCapas">
		<ParameterPorts>
			<Inputs>
				<xsl:apply-templates select="./me:Inputs" mode="forExecCapas">
					<xsl:sort select="@id|@idRef" order="ascending"/>
				</xsl:apply-templates>
			</Inputs>
			<Outputs>
				<xsl:apply-templates select="./me:Outputs" mode="forExecCapas">
					<xsl:sort select="@id|@idRef" order="ascending"/>
				</xsl:apply-templates>
			</Outputs>
		</ParameterPorts>
	</xsl:template>		
	<!--Template for Inputs-->
	<xsl:template match="me:Inputs" mode="forExecCapas">
		<xsl:apply-templates select="./me:Variable | ./me:VariableBoolean | ./me:VariableNum | ./me:VariableString" mode="forExecCapas">
			<xsl:sort select="@reqOpt" order="descending"/>
			<xsl:sort select="@id | @idRef" order="ascending"/>
			<xsl:with-param name="inOut">IN</xsl:with-param>
		</xsl:apply-templates>
		<xsl:apply-templates select="./me:VariableRef" mode="forExecCapas">
			<xsl:sort select="@reqOpt" order="descending"/>
			<xsl:sort select="@id | @idRef" order="ascending"/>
			<xsl:with-param name="inOut">IN</xsl:with-param>
		</xsl:apply-templates>
	</xsl:template>
	<!--Template for Outputs-->
	<xsl:template match="me:Outputs" mode="forExecCapas">
		<xsl:apply-templates select="./me:Variable | ./me:VariableBoolean | ./me:VariableNum | ./me:VariableString" mode="forExecCapas">
			<xsl:sort select="@reqOpt" order="descending"/>
			<xsl:sort select="@id | @idRef" order="ascending"/>
			<xsl:with-param name="inOut">OUT</xsl:with-param>
		</xsl:apply-templates>
		<xsl:apply-templates select="./me:VariableRef" mode="forExecCapas">
			<xsl:sort select="@reqOpt" order="descending"/>
			<xsl:sort select="@id | @idRef" order="ascending"/>
			<xsl:with-param name="inOut">OUT</xsl:with-param>
		</xsl:apply-templates>
	</xsl:template>
	<!--Template for VariableString-->
	<xsl:template match="me:VariableString" mode="forExecCapas">
		<xsl:param name="inOut"/>
		<xsl:variable name="reqOpt" select="@reqOpt"/>
		<xsl:variable name="value" select="@value"/>
		<xsl:call-template name="Variable">
			<xsl:with-param name="inOut" select="$inOut"/>
			<xsl:with-param name="reqOpt" select="$reqOpt"/>
			<xsl:with-param name="value" select="$value"/>
			<xsl:with-param name="varType">STRING</xsl:with-param>
		</xsl:call-template>
	</xsl:template>
	<!--Template for VariableNum-->
	<xsl:template match="me:VariableNum" mode="forExecCapas">
		<xsl:param name="inOut"/>
		<xsl:variable name="reqOpt" select="@reqOpt"/>
		<xsl:variable name="value" select="@value"/>
		<xsl:call-template name="Variable">
			<xsl:with-param name="inOut" select="$inOut"/>
			<xsl:with-param name="reqOpt" select="$reqOpt"/>
			<xsl:with-param name="value" select="$value"/>
		</xsl:call-template>
	</xsl:template>
	<!--Template for VariableBoolean-->
	<xsl:template match="me:VariableBoolean" mode="forExecCapas">
		<xsl:param name="inOut"/>
		<xsl:variable name="reqOpt" select="@reqOpt"/>
		<xsl:variable name="value" select="@value"/>
		<xsl:call-template name="Variable">
			<xsl:with-param name="inOut" select="$inOut"/>
			<xsl:with-param name="reqOpt" select="$reqOpt"/>
			<xsl:with-param name="value" select="$value"/>
		</xsl:call-template>
	</xsl:template>
	<!--Template for Variable-->
	<xsl:template match="me:Variable" mode="forExecCapas">
		<xsl:param name="inOut"/>
		<xsl:variable name="reqOpt" select="@reqOpt"/>
		<xsl:variable name="value" select="@value"/>
		<xsl:call-template name="Variable">
			<xsl:with-param name="inOut" select="$inOut"/>
			<xsl:with-param name="reqOpt" select="$reqOpt"/>
			<xsl:with-param name="value" select="$value"/>
		</xsl:call-template>
	</xsl:template>
	<!--Template for Variable-->
	<xsl:template name="Variable">
		<xsl:param name="inOut"/>
		<xsl:param name="reqOpt"/>
		<xsl:param name="value"/>
		<xsl:param name="varType"/>
		<!--Sets the default value for reqOpt, if missing-->
		<xsl:variable name="reqOpt2">
			<xsl:choose>
				<xsl:when test="string-length($reqOpt)=0">REQ</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$reqOpt"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!--Produce the output-->
		<Symbol>
			<!-- Copy all attributes by default -->
			<xsl:apply-templates select="./@*"/>
			<xsl:if test="$inOut='IN'">
				<xsl:attribute name="interfaceType">INPUT</xsl:attribute>
			</xsl:if>
			<xsl:if test="$inOut='OUT'">
				<xsl:attribute name="interfaceType">OUTPUT</xsl:attribute>
			</xsl:if>
			<xsl:attribute name="reqOpt"><xsl:value-of select="$reqOpt2"/></xsl:attribute>
			<xsl:attribute name="connectionMethod">ACYCLIC</xsl:attribute>
<!-- TBD Additional descriptive information is left out -->
<!--			<Name>
				<String lang="en">
					<xsl:value-of select="@name"/>
				</String>
			</Name>
			<Comment>
				<String lang="en">Variable <xsl:value-of select="@name"/> is <xsl:value-of select="$reqOpt2"/>. Value is <xsl:value-of select="@min"/> - <xsl:value-of select="@max"/>. With increment of <xsl:value-of select="@increment"/>
					<xsl:value-of select="@unit"/>. Decade is <xsl:value-of select="@decade"/>. Description: <xsl:value-of select="@description"/>
				</String>
			</Comment> -->
		</Symbol>
	</xsl:template>
	<!--Template for VariableRef-->
	<xsl:template match="me:VariableRef" mode="forExecCapas">
		<xsl:param name="inOut"/>
		<xsl:variable name="idRef" select="@idRef"/>
		<xsl:variable name="reqOpt" select="@reqOpt"/>
		<xsl:variable name="value" select="@value"/>
		<!--Searches detailed specification from all possible key lists-->
		<!--<xsl:for-each select="key('keyVariable',$idRef)|key('keyVariableB',$idRef)|key('keyVariableN',$idRef)|key('keyVariableS',$idRef)|key('keyBusinessProperty',$idRef)">
			<xsl:apply-templates select=".">
				<xsl:with-param name="inOut" select="$inOut"/>
				<xsl:with-param name="reqOpt" select="$reqOpt"/>
				<xsl:with-param name="value" select="$value"/>
			</xsl:apply-templates>
		</xsl:for-each>-->
		<SymbolRef>
			<xsl:attribute name="idRef"><xsl:value-of select="$idRef"/></xsl:attribute>
			<xsl:attribute name="reqOpt"><xsl:value-of select="$reqOpt"/></xsl:attribute>
			<xsl:attribute name="connectionMethod">ACYCLIC</xsl:attribute>
		</SymbolRef>
	</xsl:template>
</xsl:transform>
